# Redacted Software MultiThreading 

Yet Another C++ Threading Library

[![License: Unlicense](https://img.shields.io/badge/license-Unlicense-blue.svg)](http://unlicense.org/) ![Static Badge](https://img.shields.io/badge/Lit-Based-%20)

## Features

* Easily utilize maximum parallelization of the hardware.
* Overhead < 1% compared to running functions directly.
* Thread-safe wrappers for common STL data structures.
* Public Domain Source Code.

## API Overview

## Types
* CollisionGuard
* ConcurrentQueue
* Task
* Thread
* ThreadPool

## Usage

Using a thread-pool to execute a large set of tasks, which will utilize as many hardware threads as possible.

## Requirements

* C++ 20

## Compatibility

* Linux (gcc 13.x or newer)
* Windows 10 (1909 or newer)

## Documentation

Documentation is currently limited to source-code annotations, and the demo program.

## Contributing

Contributions to MultiThreading are welcome! If you find a bug, have a feature request, or would like to contribute code, please submit an issue or pull request.

## Acknowledgements

Developed & Maintained by William @ Redacted Software and contributors. 